PROGRAM R10Z37; { Dwikowy alfabet Morse'a }

uses Crt;

type t_znak = record
               c  : Char;      { litera lub cyfra }
               kod: string[5]  { kod kreskowo-kropkowy }
              end;


const  t=50;   { czas trwania kropki w milisekundach }
       f=2000; { czstotliwo dwiku }
       ilznak = 36; { ilo znakw w tabeli }
       s:array[1..ilznak] of t_znak = { litery, liczby i ich kody Morse'a }
      ((c:'A'; kod:'.-'),    (c:'B'; kod:'-...'),
       (c:'C'; kod:'-.-.'),  (c:'D'; kod:'-..'),
       (c:'E'; kod:'.'),     (c:'F'; kod:'..-.'),
       (c:'G'; kod:'--.'),   (c:'H'; kod:'....'),
       (c:'I'; kod:'..'),    (c:'J'; kod:'.---'),
       (c:'K'; kod:'-.-'),   (c:'L'; kod:'.-..'),
       (c:'M'; kod:'--'),    (c:'N'; kod:'-.'),
       (c:'O'; kod:'---'),   (c:'P'; kod:'.--.'),
       (c:'Q'; kod:'--.-'),  (c:'R'; kod:'.-.'),
       (c:'S'; kod:'...'),   (c:'T'; kod:'-'),
       (c:'U'; kod:'..-'),   (c:'V'; kod:'...-'),
       (c:'W'; kod:'.--'),   (c:'X'; kod:'-..-'),
       (c:'Y'; kod:'-.--'),  (c:'Z'; kod:'--..'),
       (c:'1'; kod:'.----'), (c:'2'; kod:'..---'),
       (c:'3'; kod:'...--'), (c:'4'; kod:'....-'),
       (c:'5'; kod:'.....'), (c:'6'; kod:'-....'),
       (c:'7'; kod:'--...'), (c:'8'; kod:'---..'),
       (c:'9'; kod:'----.'), (c:'0'; kod:'-----'));


     { procedura zamienia dany znak 'z' na kod dwikowy }
   procedure graj(z:Char);
   var i,n  : Integer;
       jest : Boolean;  { czy znak jest w zestawie }
   begin
      { odszukanie znaku i jego kodu w tabeli 's' }
    i:=1; jest:=false;
    repeat
     if s[i].c=z then jest:=true
                 else inc(i)
    until jest or (i=ilznak+1);

{ generujemy sygna dwikowy o czstotliwoci 'f'; przyjmujemy czas trwania
kropki = t , kreski = 3t , odstp midzy kadym sygnaem (kropk lub kresk)
= t/2, odstp midzy znakiem (litera lub cyfra) = t, odstp midzy
wyrazami =3t }
   if jest then for n:=1 to length(s[i].kod) do
     begin
     if s[i].kod[n]='.' then
                        begin sound(f);
                              delay(t);      { kropka }
                              nosound;
                              delay(t div 2) { przerwa po kadym sygalne }
                        end
                        else
                        begin sound(f);
                              delay(3*t);    { kreska }
                              nosound;
                              delay(t div 2) { przerwa po kadym sygalne }
                        end
     end
     else delay(3*t);   { pauza=3t, gdy znak spoza zestawu
                          - np. spacja na kocu wyrazu }

   delay(t) { przerwa = t, po kadym znaku }
   end;


(************ gwny modu programu ************)
var txt   : string;      { wprowadzany tekst }
    i     : Integer;     { numer znaku w tekcie }
begin
 writeln('Podaj tekst, ktry zamieni na dwikowy kod Morse''a');
 writeln('Nie uywaj polskich liter - bd je zamienia na pauzy');
 writeln('Mona uywa rwnie liczb');
 readln(txt);

 for i:=1 to length(txt) do graj(UpCase(txt[i]))
                  { wszystkie litery zamieniamy na due funkcj UpCase }
end.